/************************************************************
 *
 * COPYRIGHT (C) HITACHI,LTD. 2003-2004
 * WRITTEN BY HITACHI SYSTEMS DEVELOPMENT LABORATORY,
 *            HITACHI CENTRAL RESEARCH LABORATORY.
 *
 * Created by M.Hiramatsu <hiramatu@sdl.hitachi.co.jp>
 *
 ************************************************************/

/* i386 architecture dependant events */
/* Do not check double (or more) including.
 This file will be included many times.*/

//0x004 event
LKST_ETYPE_DEF(0x004, NORMAL, PROCESS_LTHREADGEN, "kernel_thread", \
	"pointer to kernel thread fn ", \
	"argument of kernel thread arg ", \
	"flag", \
	NULL)

#ifndef CONFIG_X86_4G
//0x010 event
LKST_ETYPE_DEF(0x010, NORMAL, INT_HARDWARE_ENTRY, "interrupt_hardware_entry", \
	"IRQ number irq ", \
	"interrupt status status ", \
	"pointer to register stack", \
	NULL)

//0x020 event
LKST_ETYPE_DEF(0x020, INLINE, EXCEPTION_ENTRY, "exception_entry", \
	"exception-handler address edi ", \
	"error code esi ", \
	"exception address if exist ", \
	NULL)

//0x021 event
LKST_ETYPE_DEF(0x021, INLINE, EXCEPTION_EXIT, "exception_exit", \
	"exception-handler address edi ", \
	NULL, \
	NULL, \
	NULL)
#endif

//0x030 event
LKST_ETYPE_DEF(0x030, NORMAL, SYSCALL_ENTRY, "system_call_entry", \
	"call number", \
	NULL, \
	NULL, \
	NULL)

//0x031 event
LKST_ETYPE_DEF(0x031, NORMAL, SYSCALL_EXIT, "system_call_exit", \
	"call number", \
	"return value errno ", \
	NULL, \
	NULL)

//0x064 event is for socket call interface (depends on arch)
LKST_ETYPE_DEF(0x064, NORMAL, NET_SOCKETIF, "net_socketif", \
	"call", \
	"args", \
	NULL, \
	NULL)

//0x080 event
LKST_ETYPE_DEF(0x080, INLINE, LK_SPINLOCK, "spin_lock", \
	"call address", \
	"lock", \
	NULL, \
	NULL)

//0x081 event
LKST_ETYPE_DEF(0x081, INLINE, LK_SPINTRYLOCK, "spin_trylock", \
	"call address", \
	"lock", \
	NULL, \
	NULL)

//0x082 event
LKST_ETYPE_DEF(0x082, INLINE, LK_SPINUNLOCK, "spin_unlock", \
	"call address", \
	"lock", \
	NULL, \
	NULL)

//0x083 event
LKST_ETYPE_DEF(0x083, INLINE, LK_WRLOCK, "write_lock", \
	"call address", \
	"rwlock", \
	NULL, \
	NULL)

//0x084 event
LKST_ETYPE_DEF(0x084, INLINE, LK_WRTRYLOCK, "write_trylock", \
	"call address", \
	"rwlock", \
	NULL, \
	NULL)

//0x085 event
LKST_ETYPE_DEF(0x085, INLINE, LK_WRUNLOCK, "write_unlock", \
	"call address", \
	"rwlock", \
	NULL, \
	NULL)

//0x086 event
LKST_ETYPE_DEF(0x086, INLINE, LK_RDLOCK, "read_lock", \
	"call address", \
	"rwlock", \
	NULL, \
	NULL)

//0x087 event
LKST_ETYPE_DEF(0x087, INLINE, LK_RDUNLOCK, "read_unlock", \
	"call address", \
	"rwlock", \
	NULL, \
	NULL)

//0x090 event
LKST_ETYPE_DEF(0x090, INLINE, O_PORTIN, "portin", \
	"port address", \
	"byte-width", \
	"value/address", \
	"call address")

//0x091 event
LKST_ETYPE_DEF(0x091, INLINE, O_PORTOUT, "portout", \
	"port address", \
	"byte-width", \
	"value/address", \
	"call address")

//0x0b0 event
LKST_ETYPE_DEF(0x0b0, NORMAL, OOPS_PGFAULT, "page_fault_oops", \
	"accessed virtual address", \
	"fault code address", \
	"error code", \
	NULL)

#ifdef CONFIG_X86_LOCAL_APIC
//0x0b1 event
LKST_ETYPE_DEF(0x0b1, NORMAL, OOPS_NMIWDOG, "nmi_watchdog_oops", \
        "current lockup address", \
         NULL, \
         NULL, \
         NULL)
#endif /*CONFIG_X86_LOCAL_APIC*/
