/************************************************************
 *
 * COPYRIGHT (C) HITACHI,LTD. 2003-2004
 * WRITTEN BY HITACHI SYSTEMS DEVELOPMENT LABORATORY,
 *            HITACHI CENTRAL RESEARCH LABORATORY.
 *
 * Created by M.Hiramatsu <hiramatu@sdl.hitachi.co.jp>
 *
 ************************************************************/

#ifndef _ARCH_IA64_LKST_H
#define _ARCH_IA64_LKST_H

#ifdef __KERNEL__
# include <linux/types.h>
#else /*!__KERNEL__*/
# include <sys/types.h>
#endif /*!__KERNEL__*/
#include <asm/page.h>

#define LKST_BIG_ENDIAN	0
#define LKST_NR_CPUS_MAX 64

typedef unsigned long lkst_ptr_t;
#define LKST_ARGP(ptr)							\
	((lkst_arg_t) ((lkst_ptr_t)(ptr)))

/* buffer size -- must be times of pagesize */
#define LKST_BUFFER_SIZE_DEFAULT	((size_t)(1*1024*1024))		/* 1MBytes*/
#define LKST_BUFFER_SIZE_MAX		((size_t)(1*1024*1024*1024))	/* 1GBytes*/
#define LKST_BUFFER_SIZE_MIN		((size_t)(PAGE_SIZE))		/* 8k/16k/64kBytes */

typedef	unsigned int	lkst_cpu_freq_t;
typedef	u_int64_t 	lkst_tsc_t;


#ifdef __KERNEL__

extern void lkst_ia64_syscall_entry(u_long, u_long, u_long, u_long);
extern void lkst_ia64_syscall_exit(u_long, u_long, u_long, u_long);

/* IA64 specific definition */
#define lkst_current_pc() \
	({ void *pc; asm volatile ("mov %0=ip" : "=r" (pc)); pc; })

#endif /*__KERNEL__*/

#endif /* _ARCH_IA64_LKST_H */
