/************************************************************
 *
 * COPYRIGHT (C) HITACHI,LTD. 2004
 * WRITTEN BY HITACHI SYSTEMS DEVELOPMENT LABORATORY,
 *            HITACHI CENTRAL RESEARCH LABORATORY.
 *
 * Written by M.Hiramatsu <hiramatu@sdl.hitachi.co.jp>
 *
 ************************************************************/

#ifndef __ASM_X86_64_LKST_H
#define __ASM_X86_64_LKST_H

#ifdef __KERNEL__
# include <linux/types.h>
#else /*!__KERNEL__*/
# include <sys/types.h>
#endif /*!__KERNEL__*/

#define LKST_BIG_ENDIAN	0
#define LKST_NR_CPUS_MAX 32

typedef unsigned long lkst_ptr_t;
#define LKST_ARGP(ptr) \
	((lkst_arg_t) ((lkst_ptr_t)(ptr)))

/* buffer size -- must be times of 4k */
#define LKST_BUFFER_SIZE_DEFAULT	(64*1024)		/* 64kBytes*/
#define LKST_BUFFER_SIZE_MAX		(1024*1024*1024)	/* 1GBytes */
#define LKST_BUFFER_SIZE_MIN		(8192)			/* 8kBytes */

typedef	unsigned int	lkst_cpu_freq_t;
typedef	u_int64_t 	lkst_tsc_t;

#ifdef __KERNEL__

static inline void * lkst_generic_current_pc(void)
{
	__label__ here;
here:
	return (&&here);
}

#define lkst_current_pc() lkst_generic_current_pc()

#endif /*__KERNEL__*/

#endif /* __ASM_X86_64_LKST_H */
