/************************************************************
 *
 * COPYRIGHT (C) HITACHI,LTD. 2001-2002
 * WRITTEN BY HITACHI SYSTEMS DEVELOPMENT LABORATORY,
 *            HITACHI CENTRAL RESEARCH LABORATORY.
 *
 * Created by K.HATASAKI <keisukeh@crl.hitachi.co.jp>
 *
 ************************************************************/

#ifndef _LINUX_LKST_EVHANDLER_H
#define _LINUX_LKST_EVHANDLER_H

#include<linux/lkst.h>

#define LKST_EVHANDLER_NAME_LEN		128

//#define LKST_EVHANDLER_NAME_DMX			"DynamicMasksetXchg"
#define LKST_EVHANDLER_NAME_DEFAULT		"DEFAULT"
#define LKST_EVHANDLER_NAME_BUFFER_SHIFT	"BUFFER_SHIFT"
#define LKST_EVHANDLER_NAME_BUFFER_SHIFT_DW	"BUFFER_SHIFT_AND_DAEMON_WAKEUP"
#define LKST_EVHANDLER_NAME_EXCEPTION		"EXCEPTION"
//#define LKST_EVHANDLER_NAME_MASKSET_XCHG	"MASKSET_XCHG"
#define LKST_EVHANDLER_NAME_LOG_STATIC		"LOG_STATIC"

typedef void (*lkst_evhandler_func) (void *phookrec, int32_t event_type,
				     lkst_arg_t arg1, lkst_arg_t arg2,
				     lkst_arg_t arg3, lkst_arg_t arg4);

typedef int (*lkst_evhandler_ctrl_func) (void *buf, size_t bufsize);

struct lkst_evhandler_ctrl_param {
	lkst_evhandler_id id;	/* event handler ID */
	void *buf;		/* a communication area for control-function */
	size_t bufsize;		/* size of the communication area */
	int ret;		/* return value from control-function */
};

struct lkst_evhandler_listent {
	lkst_evhandler_id id;	/* event handler ID */
	char name[LKST_EVHANDLER_NAME_LEN];
					/* event handler name */
};

struct lkst_evhandler_listparam {
	size_t listent_size;	/* size of the listent */
	struct lkst_evhandler_listent *listent;
				/* area to store the list of event handlers */
};

# define LKST_EVHANDLER_LISTENT_SIZE(n)					\
	     (sizeof(struct lkst_evhandler_listent) * (n))

/* same as lkst_evhandler_listent ... but different sense.*/
struct lkst_evhandler_getparam {
	lkst_evhandler_id id;			/* event handler ID */
	char name[LKST_EVHANDLER_NAME_LEN];	/* event handler name */
};

#ifdef __KERNEL__

extern int lkst_evhandler_ctrl(struct lkst_evhandler_ctrl_param
			       *evhandler_ctrl_param);

extern int lkst_evhandler_list(struct lkst_evhandler_listparam *lp);

#endif /*__KERNEL__*/

#endif				/* _LINUX_LKST_EVHANDLER_H */
